<?php 
/*
 * Image Manager module for Allmice™ CMS
 * Version 1.2.1 (2019-08-30)
 * Copyright 2019 by Any Outline LTD
 * http://www.allmice.com/cms
 * Image Manager module for Allmice CMS is released under the "GNU GENERAL PUBLIC LICENSE".
 * See LICENSE.TXT file in Allmice CMS Image Manager module root directory for more details about the license.
 */
 ?>
<?php

include $pathCoreController."Controller.php";
include $pathCoreModel."Form.php";
include $pathCoreModel."Paginator.php";

include $pathModuleModel."ImageForm.php";
include "core/includes/Model/"."DatabaseCms.php";
include $pathModuleModel."AppDatabase.php";
include $pathModuleModel."ImageManager.php";


class ImageManagerController extends Controller {  
	public $property1;

	public function __construct()
	{
	}

	public function indexEvent()
	{

		$form = new ImageForm();
		$form->setUrl(($GLOBALS['baseUrl']."/"."image-manager"."/"."process-images"));

		$modCbArray=array();

		$Database=$this->dbConfig;
		$appDb = new AppDatabase($Database['app_db']);
		$whereClauseEnd="";
		$config = $appDb->getConfigData($whereClauseEnd);

		$Other=$this->otherConfig;
		$Other['imgInputPath'] = $config['inputDirectory'];

		$imgPathSet=array();	

		if (file_exists($Other['imgInputPath']) && is_dir($Other['imgInputPath'])) {
			$path = realpath($Other['imgInputPath']);
	
			$objects = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path), RecursiveIteratorIterator::SELF_FIRST);

			foreach($objects as $name => $object){
		   	if (strstr(strtolower($name),".jpg") || strstr(strtolower($name),".jpeg") || strstr(strtolower($name),".png")){
			
					$name2=str_replace(($path."/"),"",$name);
					$imgLocSet[]=$name2;
	
					$tmpArr=explode("/",$name2);
	
					array_pop($tmpArr);
					$dir=implode("/",$tmpArr);
					if(!in_array($dir,$imgPathSet))
						$imgPathSet[]=$dir;
	
		   	}
			}
	
		}

		for($i=0;$i<count($imgPathSet);$i++){
			$modCbArray[$i]['id']=$i+1;
			$modCbArray[$i]['status']="";
		}

		
		return array(
			'form' => $form,
			'imgPathSet' => $imgPathSet,
			'modCbArray' => $modCbArray,
		);
	}
	
	public function processImagesEvent()
	{

		$form = new ImageForm();
		$form->setUrl(($GLOBALS['baseUrl']."/"."image-manager"."/"."process-images"));
		$form->setValue("submit1","Process images");

		$requiredFormat = "unknown";
		$formMap=$form->formMap;
		$Database=$this->dbConfig;
		$appDb = new AppDatabase($Database['app_db']);
		$whereClauseEnd="";
		$config = $appDb->getConfigData($whereClauseEnd);

		$imgPathSet=array();
		$imgSet=array();
		$modCbArray=array();

		$Other=$this->otherConfig;
		$Other['imgInputPath'] = 'custom/input/ImageManager/images';
		$Other['imgInputPath'] = $config['inputDirectory'];

		$Other['images'] = 20;
		$Other['images'] = $config['numberOfImages'];
		$Other['tnWidth'] = 200;
		$Other['tnWidth'] = 150;
	
		$Other['sortCode'] = 1;

		$manager = new ImageManager();

$styleTag = <<<EOD
<style>
.view-source{
	cursor: pointer;
	cursor: hand;
	padding: 4px;
	margin: 4px;
	border: 1px solid #49758a;
	background-color:#81c0c5;
	width: 110px;
	display:inline-block;
}
.source-wrapper{
  display: flex;
  align-items: center;
}
</style>
EOD;

		$GLOBALS['headTags'].=$styleTag;
		
		$outputDirectory = $config['outputDirectory'];

		$donePath=($outputDirectory."/done.txt");
		$skippedPath=($outputDirectory."/skipped.txt");
		$infoPath=($outputDirectory."/info.csv");

		$fileSetStatus=false;
		if (file_exists($donePath) && is_writable($donePath) && file_exists($skippedPath) && is_writable($skippedPath)
		 && file_exists($infoPath) && is_writable($infoPath) ) {
			$fileSetStatus=true;
		}else{
//Maybe the files are not existing yet, because the module is used first time - try to create them in opening closing way!
			$fp=fopen($donePath,'a');
			fclose($fp);
			$fp=fopen($skippedPath,'a');
			fclose($fp);
			$fp=fopen($infoPath,'a');
			fclose($fp);
//Now try again if everything is OK with these files!
			if (file_exists($donePath) && is_writable($donePath) && file_exists($skippedPath) && is_writable($skippedPath)
			 && file_exists($infoPath) && is_writable($infoPath) ) {
				$fileSetStatus=true;
			}
		}

		$outputDirStatus=false;
		$submitStatus=false;
		if (file_exists($outputDirectory) && is_dir($outputDirectory) && is_writable($outputDirectory) && isset($_POST['dirCb'])) {
			$outputDirStatus=true;
			$submitStatus=true;
	
			$outputPath=($outputDirectory."/");
	
			$doneContents="";
			$infoContents="";
			$skippedContents="";
	
			$doneArr=array();
			$skipArr=array();
			$imgChosen=array();

			$newDone="";
			$newSkipped="";
			$newInfo="";
	
			$curTime=time();
	
			$qual=90;
			$qual=$config['defaultJpgQuality'];
			$form->formMap['jpgQuality']['value']=$qual;
			$newWidth=900;
			$newWidth=$config['defaultWidth'];
			$form->formMap['newWidth']['value']=$newWidth;
	
			if (isset($_POST['jpgQuality'])){
				$qual=$_POST['jpgQuality'];
				$form->setValue('jpgQuality',$_POST['jpgQuality']);
			}
			if (isset($_POST['newWidth'])){
				$newWidth=$_POST['newWidth'];
				$form->setValue('newWidth',$_POST['newWidth']);
			}
			if (isset($_POST['imgCb'])){
				$imgChosen=$_POST['imgCb'];
			}
	
			$sortCode=$Other['sortCode'];
			if (isset($_POST['sortCode']) && isset($_POST['jpgQuality'])){
				$sortCode=$_POST['sortCode'];
				$sortCode=1;
			}
	
			if (!isset($_POST['sortCode']) && isset($_POST['jpgQuality'])){
				$sortCode=0;
			}
	
			if (!isset($_POST['sortCode']) && !isset($_POST['jpgQuality'])){
			}
	
			if($sortCode==1)
				$form->formMap['sortCode']['attributes']=array('checked' => 'checked');
			else
				$form->formMap['sortCode']['attributes']=array();
	
			if(file_exists($donePath)){
				$fp=fopen($donePath,'r');
				$doneContents = "";
				if(filesize($donePath)>0)
					$doneContents = fread($fp, filesize($donePath));
				fclose($fp);
				$doneArr=explode("\n",$doneContents);
			}
	
			if(file_exists($skippedPath)){
				$fp=fopen($skippedPath,'r');
				$skippedContents = "";
				if(filesize($skippedPath)>0)
					$skippedContents = fread($fp, filesize($skippedPath));
				fclose($fp);
				$skipArr=explode("\n",$skippedContents);
			}
	
			if(file_exists($infoPath)){
				$fp=fopen($infoPath,'r');
				$infoContents = "";
				if(filesize($infoContents)>0)
					$infoContents = fread($fp, filesize($infoPath));
				fclose($fp);
			}
	
			if($doneContents=="")
				$doneContents=("Source uri"."\n");
			if($infoContents=="")
				$infoContents=("Source uri"."\t"."New uri"."\t"."Rotation value"."\t"."Title"."\n");
			if($skippedContents=="")
				$skippedContents=("Source uri"."\n");

			if (isset($_POST['requiredFormat'])){
				$requiredFormat=$_POST['requiredFormat'];
				$form->setValue('requiredFormat',$requiredFormat);
			}

	//Processing image specific data from last form
			for($i=0;$i<$Other['images'];$i++){
	
				$rotElName="rotation".$i;
				$pathElName="path".$i;
				$titleElName="title".$i;
	
				$form->formMap[($rotElName)]=$form->formMap['rotation'];
				$form->formMap[($pathElName)]=$form->formMap['path'];
				$form->formMap[($titleElName)]=$form->formMap['title'];
	
				$form->formMap[($rotElName)]['name']=$rotElName;
				$form->formMap[($pathElName)]['name']=$pathElName;
				$form->formMap[($titleElName)]['name']=$titleElName;
	
//				$outputPath = 'custom/output/ImageManager/images';
				$outputPath = $outputDirectory;
				if (isset($_POST[($pathElName)])){
	
	
					$rotVal=$_POST[($rotElName)][0];
					$pathVal=$_POST[($pathElName)];
					$titleVal=$_POST[($titleElName)];
		
					if(in_array($i,$imgChosen)){
						$imgStatus="copied";
					
						if($rotVal==0)
							$rotDegrees=0;
						elseif($rotVal==1)
							$rotDegrees=-90;
						elseif($rotVal==2)
							$rotDegrees=90;
						elseif($rotVal==3)
							$rotDegrees=180;
		
						$imgPath = $Other['imgInputPath'];
	
						$srcLoc=$imgPath."/".$pathVal;
		
						$newImg=$this->getSmallImage($srcLoc,$newWidth);
		
						if($rotVal!=0)
							$newImg=imagerotate($newImg,$rotDegrees,0);
				
						$seqNo=$i+1;
						if($seqNo>9)
							$imgId="".$seqNo;
						else
							$imgId="0".$seqNo;
	
						$fourDigits=$curTime % 10000;
	
						if($fourDigits<1000)
							$fourDigits+=9000;
						
						$imgId=$fourDigits."-".$imgId;
	
						$newFileName=str_replace(" ","-",$titleVal);
						$newFileName=str_replace(":","",$newFileName);
						$newFileName=str_replace(";","",$newFileName);
						$newFileName=str_replace(",","",$newFileName);
	
						if($newFileName=="")
							$newFileName="newImage-".$imgId;
	
						if($sortCode==1)
							$newFileName=$imgId."-".$newFileName;
	
						if ($requiredFormat=="png"){
							$outputLoc=$outputPath."/".$newFileName.".png";
							imagepng($newImg,$outputLoc,9);
						}
						else{
							$outputLoc=$outputPath."/".$newFileName.".jpg";
							imagejpeg($newImg,$outputLoc,$qual);
						}
/*
						if (isset($_POST['fileFormat']) && $_POST['fileFormat']==0){
							$outputLoc=$outputPath."/".$newFileName.".jpg";
							imagejpeg($newImg,$outputLoc,$qual);
						}
						elseif (isset($_POST['fileFormat']) && $_POST['fileFormat']==1){
							$outputLoc=$outputPath."/".$newFileName.".png";
							imagepng($newImg,$outputLoc,9);
						}
*/				
						imagedestroy($newImg);
		
						$newInfo=($pathVal."\t".$outputLoc."\t".$rotVal."\t".$titleVal."\n");
		
						$newDone=($pathVal."\n");
						$doneContents=$doneContents.$newDone;
						$infoContents=$infoContents.$newInfo;
	
					}else{
						$imgStatus="skipped";
	
						$newSkip=($pathVal."\n");
						$skippedContents=$skippedContents.$newSkip;
					}
	
				}
			}
	
			$fp=fopen($donePath,'w');
			fwrite($fp, $doneContents);
			fclose($fp);
	
			$fp=fopen($skippedPath,'w');
			fwrite($fp, $skippedContents);
			fclose($fp);
	
	
			$fp=fopen($infoPath,'w');
			fwrite($fp, $infoContents);
			fclose($fp);
			
			if(file_exists($donePath)){
				$fp=fopen($donePath,'r');
				$doneContents = fread($fp, filesize($donePath));
				fclose($fp);
				$doneArr=explode("\n",$doneContents);
			}
	
			if(file_exists($skippedPath)){
				$fp=fopen($skippedPath,'r');
				$skippedContents = fread($fp, filesize($skippedPath));
				fclose($fp);
				$skipArr=explode("\n",$skippedContents);
			}
	
			if(file_exists($infoPath)){
				$fp=fopen($infoPath,'r');
				$infoContents = fread($fp, filesize($infoPath));
				fclose($fp);
	
			}
	
			if (isset($_POST['submit1'])){
				$selArr=$_POST['dirCb'];
	
			}
	
			$dirInd=0;
			$imgPathSet=array();	
	
			$path = realpath($Other['imgInputPath']);
			
			$files = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path), RecursiveIteratorIterator::SELF_FIRST);
	
			$data = array();
	
			foreach($files as $file){
	
				$name=$file->getPathname();
	
		   	if (strstr(strtolower($name),".jpg") || strstr(strtolower($name),".jpeg") || strstr(strtolower($name),".png")){
	
					$name2=str_replace(($path."/"),"",$name);
	
					$tmpArr=explode("/",$name2);
					array_pop($tmpArr);
					$dir=implode("/",$tmpArr);
					if(!in_array($dir,$imgPathSet)){
						$imgPathSet[]=$dir;
						$dirInd++;
					}
	
					$time = DateTime::createFromFormat('U', filemtime($file->getPathname()));
					if(in_array($dirInd,$selArr)){
						$data[] = array('filename' => $name2, 'time' => $time->getTimestamp()); // push inside
				   }
				}
			
			
			}
	
			usort($data, function($a, $b){ 
			    return $a['time'] - $b['time'];
			});
	
			$imgPath = $Other['imgInputPath'];
	
			for($i=0;$i<count($imgPathSet);$i++){
				if(in_array(($i+1),$selArr)){
					$imgDirSet[]=$imgPathSet[$i];
				}
			}

//==>Start of new code
//Since version 1.2.1 ...
//For the sake of simplicity it is required that all the input and output images would have the same format.
//There has been so far no need to manage images of different formats together.
//If there will be such need, then it would be easier in the future to add another method to this module, 
//which would first convert all the images to the same format before editing them.   
//The variable '$requiredFormat' is the result of the checking system to determine the file format.
//This system will choose input and output file format according to first input image.
if (!isset($_POST['requiredFormat'])){
	$requiredFormat=$manager->getRequiredFormat($imgDirSet,$Other['imgInputPath']);
	$form->setValue('requiredFormat',$requiredFormat);
}

//End of new code<==

			if($requiredFormat!="unknown"){

				for($i=0;$i<count($data);$i++){
					$modCbArray[$i]['id']=$i+1;
					$modCbArray[$i]['status']="";
					if(in_array($modCbArray[$i]['id'],$selArr))
						$modCbArray[$i]['status']="checked";
				}
		
				$displayCount=0;
		
				for($i=0;$i<count($data);$i++){
					$imgData['locSuffix']=$data[$i]['filename'];
		
					if(!in_array($imgData['locSuffix'],$doneArr) && !in_array($imgData['locSuffix'],$skipArr)){
		
						if($displayCount<$Other['images']){
		
							$imgData['locSuffix']=$data[$i]['filename'];
							$imgLoc=$imgPath."/".$imgData['locSuffix'];
							$imgData['small']=$this->getSmallImage($imgLoc,$Other['tnWidth']);
		
							$pathElName="path".$displayCount;
							$form->formMap[($pathElName)]['value']=$imgData['locSuffix'];
		
							$imgSet[]=$imgData;
		
							$displayCount++;
						}
					}
				}

			}

		}
		elseif (!isset($_POST['dirCb'])) {
		}

		return array(
			'form' => $form,
			'imgPathSet' => $imgPathSet,
			'imgSet' => $imgSet,
			'modCbArray' => $modCbArray,
			'imgPath' => $Other['imgInputPath'],
			'outputDirStatus' => $outputDirStatus,
			'fileSetStatus' => $fileSetStatus,
			'submitStatus' => $submitStatus,
			'requiredFormat' => $requiredFormat,
		);

	}

	public function emptyStatusFilesEvent()
	{
		
		$Other=$this->otherConfig;

		$Database=$this->dbConfig;
		$appDb = new AppDatabase($Database['app_db']);
		$whereClauseEnd="";
		$config = $appDb->getConfigData($whereClauseEnd);

		$outputDirectory = $config['outputDirectory'];


		$donePath=($outputDirectory."/done.txt");
		$skippedPath=($outputDirectory."/skipped.txt");
		$infoPath=($outputDirectory."/info.csv");
		$jpgPath=($outputDirectory."/*.jpg");

		$doneArr=array();
		$skipArr=array();

		if (isset($_POST['submit1'])){
			$selArr=$_POST['modCb'];
		}

		$writeSuccess=false;

		$fp=fopen($donePath,'w');
		$writeTest1=fwrite($fp, "");
		fclose($fp);

		$fp=fopen($skippedPath,'w');
		$writeTest2=fwrite($fp, "");
		fclose($fp);

		$fp=fopen($infoPath,'w');
		$writeTest3=fwrite($fp, "");
		fclose($fp);

		if($writeTest1==0 && $writeTest2==0 && $writeTest3==0)
			$writeSuccess=true;

		foreach(glob($jpgPath) as $file)
		    if(is_file($file))
		        @unlink($file);

		return array(
			'writeSuccess' => $writeSuccess,
		);

	}

	function getSmallImage($src,$destWidth) {

//Set transparent background for png source images
		if(strstr(strtolower($src),".png")){
			$sourceImage = imagecreatefrompng($src);
			imagealphablending($sourceImage, false);
			imagesavealpha($sourceImage, true);
			$bgColorS = imagecolorallocatealpha($sourceImage, 255, 255, 255, 127);
			imagefill($sourceImage, 0, 0, $bgColorS);
		}
		else{
			$sourceImage = imagecreatefromjpeg($src);
		}

		$width = imagesx($sourceImage);
		$height = imagesy($sourceImage);

//Allows shrinking only, not to lose quality by resizing the image bigger
		if($width>$destWidth){

// Find the "destination height" of the new destination image, relative to the destination width.
//   If width is not the longest size, then swap the destination width and height sizes, because destination width,
//      which was got from form is actually meaning longest size.

			if($width>$height)
				$destHeight = floor($height * ($destWidth / $width));
			else{
				$destHeight = $destWidth;
				$destWidth = floor($width * ($destHeight / $height));
			}	
	
// Create a new, "destination" image
			$destImage = imagecreatetruecolor($destWidth, $destHeight);

//Set transparent background for png destination images
			if(strstr(strtolower($src),".png")){
				imagealphablending($destImage, false);
				imagesavealpha($destImage, true);
				$bgColor = imagecolorallocatealpha($destImage, 255, 255, 255, 127);
				imagefill($destImage, 0, 0, $bgColor);
			}

// copy source image at a resized size
			imagecopyresampled($destImage, $sourceImage, 0, 0, 0, 0, $destWidth, $destHeight, $width, $height);
		}else{
			$destImage=$sourceImage;
		}
		
		return $destImage;

	}

}
